"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Router = void 0;
const typebox_1 = require("@sinclair/typebox");
const AnyType = typebox_1.Type.Union([typebox_1.Type.Dict(true), typebox_1.Type.String()]);
const DefaultResponses = {
    200: AnyType,
    201: AnyType,
    400: AnyType,
    404: AnyType,
    500: AnyType,
};
const Router = (handlers = []) => {
    const buildHandler = (method) => (path, body, responses) => (handler) => exports.Router([
        {
            method,
            url: path,
            handler,
            body,
            responses: responses || DefaultResponses,
        },
        ...handlers,
    ]);
    return {
        handlers,
        get: buildHandler("get"),
        head: buildHandler("head"),
        options: buildHandler("options"),
        post: buildHandler("post"),
        put: buildHandler("put"),
        delete: buildHandler("delete"),
    };
};
exports.Router = Router;
